#include "SyncGroup.hpp"
#include "Math.hpp"

float SyncGroup::update(EncoderMotor *motor, float factor)
{
    factors[motor] = factor;
    return getMinimum(motor);
}

float SyncGroup::getMinimum(EncoderMotor *exclude)
{
    float factor = 1.f;
    for (std::map<EncoderMotor*, float>::iterator it = factors.begin(); it != factors.end(); ++it)
    {
        if (it->first != exclude)
            factor = ::min(factor, it->second);
    }
    return factor;
}